
package expressions;

/*
	Expr.java
	Copyright (c) A. Clausing (achim.clausing@uni-muenster.de)

	The ancestor of all expression types
*/

public interface Expr {

	/*
		Returns the value of this expression with respect to the
		context env. tailPosition is used to tell the expression
		that it appears in tail position.
	*/	
	public Expr eval(Env env, boolean... tailPosition) throws Alarm;

	/*
		Returns the runtime type of this expression
	*/	
	public Expr type();
}

//--------------------------------------------------------------------------------------------------
