package expressions;

/*
	TailCall.java
	Copyright (c) A. Clausing (achim.clausing@uni-muenster.de)

	Tail calls are exceptions used to eliminate tail recursion.
*/

@SuppressWarnings("serial")
public class TailCall extends Alarm {
	
	private static Symbol TAIL = Symbol.forName("TAILCALL");  // Internal name

	final Function function;  // Used class Function
	final List values;        // dito
	final Env context;        // dito

	//	A TailCall exception can be used to replace a
	//	function call in tail position off the stack
	public TailCall(Function f, List v, Env e) {
		super(TAIL, VoidExpr.VOID);
		function = f;
		values = v;
		context = e;
	}
}

//--------------------------------------------------------------------------------------------------
