
package expressions;

/*
	VoidExpr.java
	Copyright (c) A. Clausing (achim.clausing@uni-muenster.de)

	This class provides the void expression
*/

public class VoidExpr implements Expr {
	
	// VOID is the sole instance of class VoidExpr
	public final static VoidExpr VOID = new VoidExpr();

	// Constructor
	private VoidExpr() {
		super();
	}

	// Runtime type
	public Expr type() {
		return Symbol.forName("Void");
	}

	// Evaluation
	public Expr eval(Env env, boolean... tailPosition) {
		return this;
	}

	// String representation
	public String toString() {
		return "";
	}
}

//--------------------------------------------------------------------------------------------------
