	
package expressions;

/*
	StreamOp.java
	Copyright (c) A. Clausing (achim.clausing@uni-muenster.de)

	The operators for Streams
*/

public abstract class StreamOp extends Operator {

	protected Stream checkStream(Expr e) throws Alarm {
		return Stream.checkStream(e);
	}
}

class Operator_scons extends StreamOp {
	public Expr apply(List args, Env env) throws Alarm {
		checkArity(args, 2);
		Expr head = args.first().eval(env);
		Expr tail = args.second(); // Unevaluated!
		return new Stream(head, tail, env);
	}
}

class Operator_scar extends StreamOp {
	public Expr apply(List args, Env env) throws Alarm {
		checkArity(args, 1);
		Stream s = checkStream(args.first().eval(env));
		return s.car();
	}
}

class Operator_scdr extends StreamOp {
	public Expr apply(List args, Env env) throws Alarm {
		checkArity(args, 1);
		Stream s = checkStream(args.first().eval(env));
		return s.cdr();
	}
}

//------------------------------------------------------------------------------
