
package expressions;

/*
	Method.java
	Copyright (c) A. Clausing (achim.clausing@uni-muenster.de)

	The type Method for t.Java
*/

public class Method extends Function {

	/*
		The t.Java class to which this method belongs
	*/
	private ClassObj classObj;
	public  ClassObj classObj() { return classObj; }

	/*
		Constructor
	*/
	public Method(ClassObj c, List formals, Expr body, Env env, Symbol name) {
		super(formals, body, env, name);
		classObj = c;
	}

	/*
		Tracing state.
		(Overrides method tracing() from class Function.)
	*/
	public boolean tracing() {
		return classObj.tracing();
	}

	/*
		String representation
	*/
	public String toString() {
		return "method[" + classObj.className() + "_" + name + "]";
	}

	/*
		Name of this method
	*/
	public Symbol name() {
		return Symbol.forName(toString());
	}
}

//--------------------------------------------------------------------------------------------------
